routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\MarcaController;
use App\Http\Controllers\ModeloController;
use App\Http\Controllers\SessionController;
use App\Http\Controllers\RegisterController;
use App\Http\Controllers\VehiculoController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

// rutas de los CRUDS
Route::resource('modelos', ModeloController::class)->middleware('auth');
Route::resource('marcas', MarcaController::class)->middleware('auth');
Route::resource('vehiculos', VehiculoController::class)->middleware('auth');

// rutas de autenticación
Route::get('/register', [RegisterController::class, 'create'])->name('auth.register');
Route::post('/register', [RegisterController::class, 'store'])->name('auth.store');
Route::get('/login', [SessionController::class, 'create'])->name('auth.login');
Route::post('/home', [SessionController::class, 'entrar'])->name('auth.entrar');
Route::get('/logout', [SessionController::class, 'destroy'])->name('auth.destroy')->middleware('auth');

// ruta para filtrar modelos por la marca
Route::get('/brands/list/{brand}', [ModeloController::class, 'lista'])->name('brand.lista')->middleware('auth');

app/Models/Marca.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Marca extends Model
{
    use HasFactory;

    protected $table = "marcas";

    protected $fillable = [
        'name',
        'description',
    ];

    public function modelo()
    {
        return $this->hasMany(Modelo::class, 'id_brand');
    }

    public function vehiculo()
    {
        return $this->hasMany(Vehiculo::class, 'id_brand');
    }
}

app/Http/Controllers/MarcaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Marca;
use Illuminate\Http\Request;
use Yajra\DataTables\Facades\DataTables;

class MarcaController extends Controller
{

    // función para llamar la tabla con todos los registros
    public function index(){
        $marcas = Marca::where('status', '=', 1)->get();
        return view('marcas.index', compact('marcas'));
    }

    // función para llamar el formulario
    public function create(){
        return view('marcas.create');
    }

    // función para guardar un registro nuevo
    public function store(Request $request){
        $request->validate([
            'name' => 'required|max:30',
            'description' => 'required|max:90',
        ]);
        $marcas = new Marca();
        $marcas->name = $request->name;
        $marcas->description = $request->description;
        $marcas->save();
        return response()->json(['success' => true]);
    }

    // función para llamar el formulario con información del registro a editar
    public function edit($id){
        $marcas = Marca::where('id', '=', $id)->get()->first();
        return view('marcas.edit', compact('marcas'));
    }

    // función para modificar un registro
    public function update(Request $request, $id){
        $request->validate([
            'name' => 'required|max:30',
            'description' => 'required|max:90',
        ]);
        $marcas = Marca::where('id', '=', $id)->get()->first();
        $marcas->name = $request->name;
        $marcas->description = $request->description;
        $marcas->save();
        return response()->json(['success' => true]);
    }

    // función para eliminar logicamente un registro
    public function destroy(Request $request, $id){
        $marcas = Marca::where('id', '=', $id)->get()->first();
        $marcas->status = '0';
        $marcas->save();
        return response()->json(['success' => true]);
    }
}

resources/views/marcas/create.blade.php
@extends('layouts.index')

@section('content')
    <div class="">
        <form action="" id="formMarca" method="post">
            @csrf   
            <div class="form-group mb-3 mt-5">
                <div class="form-group mb-3">
                    <label for="">Nombre:</label>
                    <input type="text" name="name" id="name" class="form-control" placeholder="escribe una nombre" aria-describedby="helpId" required>
                </div>
                <div class="form-group mb-3">
                    <label for="">Descripcion:</label>
                    <input type="text" name="description" id="description" class="form-control" placeholder="escribe una descripcion" aria-describedby="helpId" required>
                </div>
            </div>
            
            <div class="float-right">
                <button class="btn btn-success" id="btnRegistrarMarca">Registrar</button>
                <a class="btn btn-warning" href="{{route('marcas.index')}}" id="btnRegistrarVehiculo">Atras</a>
            </div>
        </form>
    </div> 
@endsection

@section('javascript')

    <!-- Petición ajax para guardar un registro en la base de datos -->
    <script>
        $('#btnRegistrarMarca').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let name  = $('#name').val();
            let description = $('#description').val();
            let _token = $('input[name=_token]').val();
            // Petición ajax
            $.ajax({
                type: "POST",
                url: "{{route('marcas.store')}}",
                data: {
                    name: name,
                    description: description,
                    _token: _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Registro exitoso', 'Nuevo registro');
                        window.location.href = '/marcas'
                    }, 1000);
                },
                error: function (err) {
                    if (err.status == 422) { // when status code is 422, it's a validation issue
                        $.each(err.responseJSON.errors, function (i, error) {
                            var el = $(document).find('[name="'+i+'"]');
                            el.after($('<span style="color: red;">'+error[0]+'</span>'));
                        });
                    }
                }
            });
        });
    </script>
@endsection

resources/views/marcas/edit.blade.php
@extends('layouts.index')

@section('content')
    <div class="container">
        <div class="">
            <form action="" id="formMarca" method="post">
                @csrf   
                @method('PUT')
                <div class="form-group mb-3 mt-5">
                    <div class="form-group mb-3">
                        <label for="">Nombre:</label>
                        <input type="text" name="name" id="name" class="form-control" placeholder="escribe una nombre" autofocus aria-describedby="helpId" value="{{$marcas->name}}" required>
                    </div>
                    <div class="form-group mb-3">
                        <label for="">Descripcion:</label>
                        <input type="text" name="description" id="description" class="form-control" placeholder="escribe una descripcion" aria-describedby="helpId" value="{{$marcas->description}}" required>
                    </div>
                </div>
                
                <div class="float-right">
                    <button class="btn btn-success" id="btnEditarMarca">Editar</button>
                    <a class="btn btn-warning" href="{{route('marcas.index')}}" id="btnRegistrarVehiculo">Atras</a>
                </div>
            </form>
        </div>
    </div>    
@endsection

@section('javascript')

    <!-- Petición ajax para modificar un registro en la base de datos -->
    <script>
        $('#btnEditarMarca').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let name  = $('#name').val();
            let description = $('#description').val();
            let _token = $('input[name=_token]').val();
            // Petición ajax
            $.ajax({
                type: "PUT",
                url: "{{route('marcas.update', $marcas->id)}}",
                data: {
                    name: name,
                    description: description,
                    _token: _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Modificación exitosa', 'Modificar registro');
                        window.location.href = '/marcas'
                    }, 1000);
                },
                error: function (err) {
                    if (err.status == 422) { // when status code is 422, it's a validation issue
                        $.each(err.responseJSON.errors, function (i, error) {
                            var el = $(document).find('[name="'+i+'"]');
                            el.after($('<span style="color: red;">'+error[0]+'</span>'));
                        });
                    }
                }
            });
        });
    </script>
@endsection

resources/views/marcas/index.blade.php
@extends('layouts.index')

@section('content')

    <div class="container">
        <div class="row mb-5 mt-5">
            <div class="col-md-6" style="display:flex;">
                <h3 class="text-secondary">Marcas</h3>
                <a href="" class="btn btn-primary" style="margin-left: 30px;" id="btnNuevaMarca">Nueva marca</a>
            </div>
            <div class="col-md-6">
            </div>
        </div>
    </div>
    <div class="col-md-12">
        <table class="cell-border" id="table-generic">
            <thead class="thead-light">
                <tr>
                    <th class="text-center">ID</th>
                    <th class="text-center">NOMBRE</th>
                    <th class="text-center">DESCRIPCIÓN</th>
                    <th class="text-center">ACCIONES</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($marcas as $marca)
                    <tr id="rowId-{{$marca->id}}">
                        <td class="text-center">
                            {{$marca->id}}
                        </td>
                        <td class="text-center">
                            {{$marca->name}}
                        </td>
                        <td class="text-center">
                            {{$marca->description}}
                        </td>
                        <td class="text-center">
                            <div class="btn-group">
                                <a href="{{route('marcas.edit', $marca->id)}}" id="editBtn" class="btn btn-warning" title="Modificar">Editar</a>
                                <form action="" style="display: inline" method="POST">
                                    @csrf
                                    @method('DELETE')
                                    <button id="btnDelete" valor="{{$marca->id}}" class="btn btn-danger" title="Eliminar"> Eliminar </button>
                                </form>
                            </div>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>
    </div>

@endsection

@section('javascript')

    <!-- Petición ajax para llamar a la vista create -->
    <script>
        $('#btnNuevaMarca').on('click', function(e){
            // Petición ajax
            $.ajax({
                type: "GET",
                url: "{{route('marcas.create')}}",
                success: function() { 
                    window.location.href = '/marcas/create'
                },
                error: function(xhr, ajaxOptions, thrownerror) { }
            })
        });
    </script>
    <script>
        // Ajax para eliminar un registro
        $(document).on('click', '#btnDelete', function(e){
            if(confirm('Está seguro que quiere eliminar este registro?')){
                e.preventDefault();
                let id = $(this).attr('valor');
                let _token = $('input[name=_token]').val();
                $.ajax({
                    type: "DELETE",
                    url: `marcas/${id}`,
                    data: {
                        id: id,
                        _token: _token
                    },
                    success:function(response){
                        toastr.success('Registro Eliminado', 'Eliminar', 3000);
                        $('#rowId-'+id).remove();
                    },
                    error: function (err) {
                        if(err.status == 422){
                            $.each(err.responseJSON.errors, function (i,error) {
                                toastr.success('error en eliminacion', +error[0], 3000);
                            })
                        }
                    }
                });
            }
        });
    </script>
@endsection